'Backup program by Charles Dietz

'ver 1.33 (05-31-2010)
' - changed data storage from CSIDL_COMMON_DOCUMENTS to CSIDL_COMMON_APPDATA
'ver 1.34 (06-03-2010)
' - improved print to "myBackup.log"
'ver 1.35 (06-05-2010)
' - corrected bug running autoBackup if already run that day
'ver 1.40 (08-08-2010)
' - corrected serious bug in readDir(), hSearch, hSrch AS LONG (was DWORD)
' - corrected autoBackup output dialog box
' - added checkmark to File > Run autoBackup menu item when autoBackup is loaded
' - removed File > Autobackup file menu item (file selected when autoBackup is run)                
' - remove checkmarks as sources are backed up
'ver 1.41 (08-14-2010)
' - changed checkmark on 'Run autoBackup' menu item to grayed
' - user is notified and autoBackup is killed when target folder is not found
'ver 1.50 (08-24-2010)
' - added read-only file "autoBackup" with autoBackup configure data
' - changed Help menu Info items to View menu
' - grayed out File menu 'Kill autoBackup' when autoBackup not active
' - eliminated need for lastDate variable
'ver 1.51 (09-03-2010)
' - added 'Remove folder' button to remove a source folder
' - added 'Refresh' button to test existance of target folder
' - check existance of target folder when file is opened and signal status bar accordingly
' - added icon for the program: shield with arrow back & up plus 'B' & 'u'
'ver 1.60 (09-10-2010)
' - updated help file... more cautions for using Restore
' - made several corrections and streamlined program code
'ver 1.70 (10-07-2010)
' - added smooth progressbar over the source folders
' - added new subroutines Progress(textbox, pct) and sizeDir()
' - added listed(), listedSize() arrays to be saved in myBackup.ini
' - added Cancel button to backupDlg() dialog box
'ver 1.75 (10-10-2010)
' - changed to DIALOG DOEVENTS 0 so as to speed up readDir() and sizeDir()
' - streamlined readDir(0) and sizeDir() per code by Casey Sprangel of www.ifxGroup.net
' - removed listed(), listedSize() arrays (not needed because of speed increase)
'ver 1.80 (03-15-2011)
' - replaced backupDlg dialog and its accompanying procedure with a simple msgbox
' - added feature to return required free disk space and available free disk space
' - sizeDir routine can now retrieve file sizes in addition to number of files
' - added percentage to statusbar (complements source progress bars shown)
'ver 1.90 (06-24-2011)
' - prevent sleep and hybernate mode during backup with SetThreadExecutionState() API
' - can now backup unlimited folders using listview control instead of 8 textboxes
' - corrected statusbar panel 1 showing path & file being scanned
'ver 1.91 (09-01-2011)
' - added lastDate array for last time source file was backed up, shown in statusbar
'ver 1.92 (10-07-2011)
' - lastDate array updated in backupNow() whenever backup is run (ignore fileChanged)
' - expanded autoBackup for daily, weekly, bi-weekly, and monthly intervals
' - revised and improved autoBackup code in both 'autoBackup.bas' and 'myBackup.bas'
' - changed contents of autoBackup file (backup file, autoInterval, nextBackup)
' - used SetWaitableTimer() and WaitForSingleObject() rather than SetTimer()
'ver 1.93 (01-29-2012)
' - corrected target to reflect all of source path after the drive (not last folder of path)
' - added button to clear/set all source checkboxes
' - added more info with Refresh (for checking on target... drive or folder)
'ver 2.00 (05-06-2012)
' - fixed problem saving a new file, and in particular, the first new file
' - added exception feature to skip any folder specified as an exception
'ver 2.01 (07-22-2012)
' - modified backup results... when t < 1 then sTime = "less than a second" 
'ver 2.02 (08-04-2012)
' - modified backup results once more, improving backup time format
' - improved autoBackup by adding beginning date to autoInterval selection
'ver 2.03 (04-12-2013)
' - changed auto backup time to 2am (so as to better accomodate daylight savings)
' - changed monthly autoInterval to 28 days so as to backup same day of week
'ver 2.04 (05-20-2013)
' - correction, added daysInMonth function for maxDays variable in autoBackup
' - added item to top of file menu named New
'ver 2.05 (05-24-2013)
' - improved messages relating to valid target folders using getDriveType()                      
'ver 2.06 (09-12-2013)
' - allow for SetThreadExecutionState() differences in Windows XP, Vista, 7 and 8
' - disable backup button when beginning new configuration file definition
'ver 2.07 (09-14-2013)
' - removed refresh button (backup button checks target and source files)
' - made various code improvements and program message clarifications
'ver 2.08
'ver 2.09 (05/22/2014)
' - show file being copied on statusbar before copy, not after
' - added browse display for defining exceptions with Add Button
'ver 2.10 (07-13-2014)
' - added function fileBlockCopy() to allow status updates during large file copying
' - added label "waiting for file copy to finish" for big files using block copy                     
' - added window for viewing the log file, along with still using SHELL function
' - added fileBlockCopy into autoBackup and replicated copyDir routine as much as possible
'ver 2.11 (07-15-2014)
' - corrected where autobackup source files are copied... e.g. c:\users\chas\ --> e:\chas\
'ver 2.12 (07-23-2014)
' - corrected nextBackup when booting computer and it is past due date for autoBackup
' - improved running perception by updating statusbar for each file as it's examined       
'ver 2.16 (02-11-2017)                                                    
' - list only configuration files that exist in menu list of 4 most recent
' - add caution that "source files will be overridden by their earlier backups"
' - improved exemptions... edit and replace instead of delete and add (saves the order too)
' - corrected creation and viewing of the log file... no need for notePad now
' - change to my own help file with appHelp 
' - change "autoBackup" binary file to "autoBackup.ini" sequential file
' - change name of routines: sizeDir() to dirSizeReqd and getReqdSpace() to diskSpaceReqd()
' - allow user to choose auto backup time of day (saved as 24-hr military time)
' - added function regTime() to autoBackup.bas for more efficient code... 24-hr to 12-hr time
'ver 2.17 (02/14/2017)                                                                                      
' - added function regTime() to myBackup.bas, for AutoBackup Info
' - removed code to update next auto backup date in myBackup.bas
' - improved code to update next auto backup date in autoBackup.bas
' - put CopyToTxt label (old target label) on same line as CopyTo button
'ver 3.00 (03/18/2017)
' - include version and computer name in backup (.bku) files
' - prompt user if the backup file is for a different computer
' - dataFolder chosen as folder holding the program if containing data files
' - view autoBackup info to include copyTo folder and source files (pending)                                                                                        
'----------------------------------------------------------------------------------------------
'Notes:
'  run =  1: backup
'      =  2: restore
'      =  3: required disk space

'  running =  1: running backup
'          =  2: running restore
'          =  0: interrupted or done                                                           
'          = -1: cancelled or closed               

' - backup source files for selected folders that are later than the target files
' - restore all backed up source files for selected folders                         
' - Manifest required in myBackup.rc since writing to ProgramData system folder 
'----------------------------------------------------------------------------------------------
%ES_AWAYMODE_REQUIRED = &h00000040                            

'%IDD_DIALOG1     =  101

%IDC_Textbox      = 1010
%IDC_Listbox      = 1020
%IDC_Statusbar    = 1030
%IDC_CopyToTxt    = 1041
%IDC_CopyTo       = 1042
%IDC_AddSource    = 1043
%IDC_Except       = 1044
%IDC_DelSource    = 1045
%IDC_SetCkboxes   = 1046
%IDC_Backup       = 1051
%IDC_Restore      = 1052
%IDC_Close        = 1053
%IDC_Waiting      = 1054
%IDC_CopyLog      = 1055
%IDC_Start        = 1057
%IDC_Done         = 1058
%IDC_ComboX       = 1060
%IDC_SuggestX     = 1061
%IDC_AddX         = 1062 
%IDC_DeleteX      = 1063
%IDC_ClearX       = 1064
%IDC_OkX          = 1065
%IDC_Listview     = 1070
%IDC_Interval     = 1080  'thru 1084
%IDC_AutoTime     = 1090
%IDC_AutoBegin    = 1091
%IDC_InfoText     = 1092

%IDM_New          = 2000
%IDM_Open         = 2001
%IDM_Save         = 2002
%IDM_SaveAs       = 2003
%IDM_Backup       = 2004
%IDM_Restore      = 2005
%IDM_RunAutoBU    = 2006
%IDM_KillAutoBU   = 2007
%IDM_Exit         = 2008
%IDM_BackupInfo   = 2021
%IDM_RestorInfo   = 2022
%IDM_Exceptions   = 2023
%IDM_AutoBUInfo   = 2024
%IDM_LogFile      = 2025
%IDM_ReqdSpace    = 2026
%IDM_Help         = 2031
%IDM_About        = 2032

GLOBAL hDlg, hMenu, hFileMenu, hViewMenu, hListview, hTextbox, hStatusbarDC, hHelpMenu AS LONG
GLOBAL numSources, numFiles, numExcept, run, running, fileBackedUp, fileChanged, numErrors AS LONG
GLOBAL logFile, statusbarLen, nCount, totalCount, nProgress, nTextbox, autoInterval, nSel AS LONG
GLOBAL start, lastTime AS DOUBLE
GLOBAL dataFolder, startUpFolder, thisFile, iniFile, fileName, computerName AS STRING
GLOBAL sCopyTo, sAutoFile, sSource, sTarget, autoBegin, autoTime, copyLog AS STRING
GLOBAL sources(), except(), recent() AS STRING
GLOBAL lastDate(), lastDatePos, clusterSize AS DWORD

'killProcess types
%TH32CS_SNAPPROCESS = &H2
%MAX_MODULE_NAME32 = 255
TYPE PROCESSENTRY32
   dwSize               AS DWORD
   cntUsage             AS DWORD
   th32ProcessID        AS DWORD                              ' This process
   th32DefaultHeapID    AS LONG PTR
   th32ModuleID         AS DWORD                              ' Associated exe
   cntThreads           AS DWORD
   th32ParentProcessID  AS DWORD                              ' This process's parent process
   pcPriClassBase       AS LONG                               ' Base priority of process threads
   dwFlags              AS DWORD
   szExeFile            AS ASCIIZ * %MAX_PATH                 ' Path
END TYPE

TYPE MODULEENTRY32
   dwSize               AS DWORD
   th32ModuleID         AS DWORD                              ' This module
   th32ProcessID        AS DWORD                              ' Owning process
   GlblcntUsage         AS DWORD                              ' Global usage count on the module
   ProccntUsage         AS DWORD                              ' Module usage count in th32ProcessID's context
   modBaseAddr          AS BYTE PTR                           ' Base address of module in th32ProcessID's context
   modBaseSize          AS DWORD                              ' Size in bytes of module starting at modBaseAddr
   hModule              AS DWORD                              ' The hModule of this module in th32ProcessID's context
   szModule             AS ASCIIZ * (%MAX_MODULE_NAME32 + 1)
   szExePath            AS ASCIIZ * %MAX_PATH
END TYPE

'create shortcut
DECLARE FUNCTION IShellLink_Call0(BYVAL pUnk AS LONG) AS LONG
DECLARE FUNCTION IShellLink_Call1(BYVAL pUnk AS LONG, BYVAL p1 AS LONG) AS LONG
DECLARE FUNCTION IShellLink_Call2(BYVAL pUnk AS LONG, BYVAL p1 AS LONG, BYVAL p2 AS LONG) AS LONG
DECLARE FUNCTION CoCreateInstance LIB "ole32.dll" ALIAS "CoCreateInstance" (rclsid AS GUIDAPI, _
        pUnkOuter AS ANY, BYVAL dwClsContext AS DWORD, riid AS GUIDAPI, ppv AS any) AS LONG  'DWORD
DECLARE SUB CoUninitialize LIB "ole32.dll" ALIAS "CoUninitialize"
DECLARE SUB CoTaskMemFree LIB "ole32.dll" ALIAS "CoTaskMemFree" (pv AS any)

'killProcess routines
DECLARE FUNCTION CreateToolhelp32Snapshot (BYVAL dwFlags AS DWORD, BYVAL th32ProcessID AS DWORD) AS LONG
DECLARE FUNCTION Process32First           (BYVAL hSnapshot AS DWORD, pe AS PROCESSENTRY32)  AS LONG
DECLARE FUNCTION Process32Next            (BYVAL hSnapshot AS DWORD, pe AS PROCESSENTRY32)  AS LONG
DECLARE FUNCTION Module32First            (BYVAL hSnapshot AS DWORD, ME AS MODULEENTRY32)   AS LONG
DECLARE FUNCTION Module32Next             (BYVAL hSnapshot AS DWORD, ME AS MODULEENTRY32)   AS LONG
DECLARE FUNCTION EnumProcesses            (idProcess AS DWORD, BYVAL cb AS DWORD, cbNeeded AS DWORD) AS LONG
DECLARE FUNCTION GetModuleFileNameEx      (BYVAL hProcess AS DWORD, BYVAL hModule AS DWORD, ModuleName AS ASCIIZ, BYVAL nSize AS DWORD) AS DWORD
DECLARE FUNCTION EnumProcessModules       (BYVAL hProcess AS DWORD, hModule AS DWORD, BYVAL cb AS DWORD, cbNeeded AS DWORD) AS LONG
'create help
DECLARE FUNCTION HtmlHelp LIB "hhctrl.ocx" ALIAS "HtmlHelpA" _
          (BYVAL LONG, ASCIIZ, BYVAL LONG, BYVAL LONG ) AS LONG
