#COMPILE EXE                                                    
#DIM ALL                                                        
#INCLUDE "WIN32API.INC"                                  
'#INCLUDE "debug.inc"

%IDC_Start  = 101
%IDC_Done   = 102
%IDC_Stop   = 103
%IDC_Timer  = 200
                                                         
GLOBAL hMain, hStatus, running, autoInterval AS LONG
GLOBAL numSources, numFiles, numExcept, logFile, nErr AS LONG
GLOBAL dataFolder, thisFile, sSource, sInterval, copyLog AS STRING
GLOBAL sCopyTo, sTarget, sAutoFile, autoTime, nextBackup AS STRING
global except(), sources() as string
global clusterSize as dword

'killProcess types
%TH32CS_SNAPPROCESS = &H2
%MAX_MODULE_NAME32 = 255
TYPE PROCESSENTRY32
   dwSize               AS DWORD
   cntUsage             AS DWORD
   th32ProcessID        AS DWORD                              ' This process
   th32DefaultHeapID    AS LONG PTR
   th32ModuleID         AS DWORD                              ' Associated exe
   cntThreads           AS DWORD
   th32ParentProcessID  AS DWORD                              ' This process's parent process
   pcPriClassBase       AS LONG                               ' Base priority of process threads
   dwFlags              AS DWORD
   szExeFile            AS ASCIIZ * %MAX_PATH                 ' Path
END TYPE

TYPE MODULEENTRY32
   dwSize               AS DWORD
   th32ModuleID         AS DWORD                              ' This module
   th32ProcessID        AS DWORD                              ' Owning process
   GlblcntUsage         AS DWORD                              ' Global usage count on the module
   ProccntUsage         AS DWORD                              ' Module usage count in th32ProcessID's context
   modBaseAddr          AS BYTE PTR                           ' Base address of module in th32ProcessID's context
   modBaseSize          AS DWORD                              ' Size in bytes of module starting at modBaseAddr
   hModule              AS DWORD                              ' The hModule of this module in th32ProcessID's context
   szModule             AS ASCIIZ * (%MAX_MODULE_NAME32 + 1)
   szExePath            AS ASCIIZ * %MAX_PATH
END TYPE                                                                             

DECLARE FUNCTION CreateToolhelp32Snapshot (BYVAL dwFlags AS DWORD, BYVAL th32ProcessID AS DWORD) AS LONG
DECLARE FUNCTION Process32First           (BYVAL hSnapshot AS DWORD, pe AS PROCESSENTRY32)  AS LONG
DECLARE FUNCTION Process32Next            (BYVAL hSnapshot AS DWORD, pe AS PROCESSENTRY32)  AS LONG
DECLARE FUNCTION EnumProcesses            (idProcess AS DWORD, BYVAL cb AS DWORD, cbNeeded AS DWORD) AS LONG
DECLARE FUNCTION GetModuleFileNameEx      (BYVAL hProcess AS DWORD, BYVAL hModule AS DWORD, ModuleName AS ASCIIZ, BYVAL nSize AS DWORD) AS DWORD
DECLARE FUNCTION EnumProcessModules       (BYVAL hProcess AS DWORD, hModule AS DWORD, BYVAL cb AS DWORD, cbNeeded AS DWORD) AS LONG

FUNCTION PBMAIN()
   LOCAL hMutex AS LONG
   IF alreadyRunning(hMutex, "my AutoBackup") THEN
      MSGBOX "autoBackup.exe is already loaded", %MB_ICONINFORMATION, "Auto Backup"
      EXIT FUNCTION
   END IF                                           
   DIALOG NEW 0, "Auto Backup", , , 0, 0 TO hMain
   DIALOG SHOW STATE hMain, %SW_HIDE
   DIALOG SHOW MODAL hMain CALL mainProc
END FUNCTION

CALLBACK FUNCTION mainProc()                                            
   LOCAL m, n, hFile, day, mo, yr, maxDays AS LONG           
   LOCAL t AS DOUBLE
   LOCAL s, ss, sDate, sNext, sAutoBegin, sIntervall as string
   STATIC runNow, wait, getNextBackupDate AS LONG
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG 
         'define Windows data folder
         dataFolder = specialFolder(%CSIDL_COMMON_APPDATA)
         IF LEN(dataFolder) = 0 THEN dataFolder = "C:\My Documents\"
         dataFolder = dataFolder + "\cgdSoftware\myBackup\"
         IF ISFOLDER(dataFolder) = 0 THEN createFolder dataFolder
         sAutoFile = dataFolder + "autoBackup.ini"
         'the file named "autoBackup.ini" defines which backup file to run and when
         'save as 24-hr military time, but display as regular time for backing uop                               
         'open autoBackup file -----------------------------------------------------------
         IF ISFILE(sAutoFile) THEN
            hFile = FREEFILE
            OPEN sAutoFile FOR input AS #hFile           
            input #hFile, thisFile
            input #hFile, autoInterval
            input #hFile, autoTime
            input #hFile, nextBackup
            CLOSE #hFile
         ELSE
            MSGBOX "File not found", %MB_ICONERROR, sAutoFile
            DIALOG END CB.HNDL: EXIT FUNCTION
         END IF
         IF ISFILE(thisFile) = 0 THEN 'check for backup definition file
            MSGBOX thisFile + "autoBackup.ini file not found", %MB_ICONERROR, "Auto Backup Error"
            DIALOG END CB.HNDL: EXIT FUNCTION
         END IF                                                      
         n = autoInterval
         sInterval = switch$(n = 1, "daily", n = 7, "weekly", n = 14, "bi-weekly", n = 28, "every 4-weeks")
         IF LEN(COMMAND$) THEN 'loaded from File menu of 'myBackup.exe'                            
            s = "Ok for next autoBackup to run " + sInterval                                          
            s = s + " at " + regTime(autoTime) + ", beginning " + nextBackup + "?"
            n = MSGBOX(s, %MB_ICONQUESTION OR %MB_YESNO, "Run AutoBackup")                    
            IF n = %IDNO THEN DIALOG END CB.HNDL: EXIT FUNCTION
         ELSE 'loaded from Windows Startup                                                
            s = "AutoBackup is scheduled to run " + sInterval + $CRLF + $CRLF _
              + "Next backup will run at " + regTime(autoTime) + " on " + nextBackup
            MSGBOX s, %MB_ICONINFORMATION OR %MB_OK, "Run AutoBackup"
         END IF
         DIALOG POST CB.HNDL, %WM_USER + 100, 0, 0
      CASE %WM_USER + 100
         DO                                   
            IF wait THEN setWaitForWakeup
            'doesn't leave setWaitForWakeup routine until time to backup has arrived
            DIALOG END hStatus
            if isfile(thisFile) = 0 then 
               msgbox "File not found", %MB_ICONERROR, thisFile: exit do
            end if 
            day = VAL(MID$(date$, 4, 2))                                        
            mo = VAL(MID$(date$, 1, 2))
            yr = VAL(MID$(date$, 7, 4))
            sDate = MID$(DATE$, 7) + MID$(DATE$, 1, 2) + MID$(DATE$, 4, 2)
            sNext = MID$(nextBackup, 7) + MID$(nextBackup, 1, 2) + MID$(nextBackup, 4, 2)
            getNextBackupDate = 0
            IF sDate > sNext OR (sDate = sNext AND left$(TIME$, 5) > autoTime) THEN
               s = "AutoBackup was scheduled to have already run..." + $CRLF _
                 + "Do you want to run it now?
               n = MSGBOX(s, %MB_ICONQUESTION OR %MB_YESNO, "Run AutoBackup")
               IF n = %IDYes THEN runNow = 1 else runNow = 0
               getNextBackupDate = 1                  
            end if
            IF runNow THEN 'check for target and run the backup
               openTheFile  'get contents of thisFile
               t = TIMER
               DO 'give network 30 secs time to find sCopyTo folder
                  IF TIMER - t >= 30 THEN EXIT DO
               LOOP UNTIL ISFOLDER(sCopyTo)
               IF ISFOLDER(sCopyTo) THEN                                            
                  autoBackupDlg: getNextBackupDate = 1                                                            
               ELSE
                  s = "CopyTo folder not found... backup not run"
                  MSGBOX s, %MB_ICONINFORMATION OR %MB_OK, sCopyTo                       
               END IF 
            END IF
            if getNextBackupDate then 'compute next scheduled auto backup date
               do
                  day = day + autoInterval
                  maxDays = daysInMonth(mo, yr)
                  IF day > maxDays THEN day = day - maxDays: INCR mo
                  IF mo > 12 THEN mo = 1: INCR yr
                  sNext = FORMAT$(yr, "0000") + FORMAT$(mo, "00") + FORMAT$(day, "00")
               loop until sNext > sDate
               nextBackup = FORMAT$(mo, "00-") + FORMAT$(day, "00-") + FORMAT$(yr, "0000")
               'reset timer and update autoBackup file ----------------------------------------------
               hFile = FREEFILE
               OPEN sAutoFile FOR output AS #hFile
               print #hFile, thisFile
               print #hFile, autoInterval
               print #hFile, autoTime
               print #hFile, nextBackup
               CLOSE #hFile
            end if 
            wait = 1: runNow = 1
         LOOP                                                                             
      CASE %WM_DESTROY
   END SELECT
END FUNCTION

FUNCTION alreadyRunning(hMutex AS LONG, mutexName AS ASCIIZ *64) AS LONG
   'check if instance of program is already running
   'Returns: 1  already running
   '         0  first instance
   hMutex = CreateMutex (BYVAL %NULL, %FALSE, BYVAL VARPTR(mutexName))
   IF hMutex THEN 'got a handle, but was it already existing?
      IF GetLastError = %Error_Already_Exists THEN FUNCTION = 1
   END IF
END FUNCTION

SUB setWaitForWakeup()
   LOCAL tq AS QUAD
   LOCAL n AS LONG
   LOCAL htimer AS DWORD
   'waitable timer: time in 100 nanosecond intervals (neg for relative time)
   htimer = CreateWaitableTimer(BYVAL %NULL, 1, "AutoBackupTimer")
   IF htimer THEN
      tq = -10000000 * getSleeptime
      SetWaitableTimer BYVAL htimer, tq, 0, BYVAL %NULL, BYVAL %NULL, 1
      WaitForSingleObject BYVAL htimer, %INFINITE
      CloseHandle htimer
   END IF
END SUB

FUNCTION getSleepTime() AS DWORD
   'compute seconds of sleep time before next scheduled backup                     
   'if current time is before                                                                
   LOCAL days, hrs, mins AS LONG                                                
   if left$(time$, 5) >= autoTime then days = autoInterval
   hrs = val(parse$(autoTime, ":", 1)) - VAL(PARSE$(time$, ":", 1))
   mins = VAL(PARSE$(autoTime, ":", 2)) - VAL(PARSE$(time$, ":", 2))
   function = 86400*days + 3600*hrs + 60*mins - VAL(PARSE$(time$, ":", 3))     
END FUNCTION

FUNCTION dayOfWeek(month AS LONG, year AS LONG, day AS LONG) AS LONG
   'The AstroDay function defined here is a modified version of the Julian date formula used by astronomers.
   'http://support.microsoft.com/kb/q109451/
   'Sun = 0, Mon = 1, Tue = 2, ...
   LOCAL astroDay AS LONG, y AS DOUBLE
   y = year + (month - 2.85) / 12
   astroDay = INT(INT(INT(367*y)-1.75*INT(y)+day) -0.75*INT(0.01*y))+1721119
   FUNCTION = (astroDay - 3) MOD 7
END FUNCTION

FUNCTION daysInMonth(mo AS LONG, yr AS LONG) AS LONG
   LOCAL days AS INTEGER
   IF mo < 8 THEN
      days = 30 + mo MOD 2
   ELSE
      days = 30 + (mo + 1) MOD 2
   END IF                                                               
   IF mo = 2 THEN
      days = 28
      IF (yr MOD 100 <> 0 OR yr MOD 400 = 0) _
         AND yr MOD 4 = 0 THEN INCR days 'leap yr
   END IF
   function = days
END FUNCTION

function regTime(t as string) as string
   't is 24-hour military time
   'return 12-hour time with am/pm attached
   local hrs, m as long, am as string                                               
   am = " am"                                                     
   if len(t) <= 5 then m = 3 else m = 6
   hrs = val(parse$(t, ":", 1))
   if hrs > 12 then hrs = hrs - 12: am = " pm"
   function = trim$(str$(hrs)) + right$(t, m) + am
end function

SUB autoBackupDlg()
   DIALOG NEW hMain, "Running Auto Backup", , , 200, 140 TO hStatus
   CONTROL ADD LABEL, hStatus, %IDC_Start, "", 15, 20, 175, 15
   CONTROL ADD LABEL, hStatus, %IDC_Done, "", 15, 50, 175, 30
   CONTROL ADD BUTTON, hStatus, %IDOK, "", 70, 100, 60, 25
   DIALOG SHOW MODAL hStatus, CALL autoBackupDlgProc
END SUB

CALLBACK FUNCTION autoBackupDlgProc()                         
   LOCAL t, start, hh, mm, ss AS DOUBLE
   LOCAL s, s1, hrs, mins, secs, sTime AS STRING
   SELECT CASE AS LONG CB.MSG
      CASE %WM_INITDIALOG
         DIALOG POST CB.HNDL, %WM_USER + 100, 0, 0
      CASE %WM_COMMAND
         IF CB.CTL = %IDOK THEN
            IF running = 1 THEN  'interrupted
                running = 0
            ELSE
               DIALOG END CB.HNDL
            END IF                                                                
         END IF
      CASE %WM_USER + 100  'backup now
         s = "Auto backup started: " + date$ + " at " + regTime(Left$(time$, 5))
         CONTROL SET TEXT CB.HNDL, %IDC_Start, s + $CRLF
         CONTROL SET TEXT CB.HNDL, %IDC_Done, ""
         CONTROL SET TEXT CB.HNDL, %IDOK, "Stop"
         DIALOG REDRAW CB.HNDL
         copyLog = ""
         copyLog = copyLog + "AutoBackup date: " + DATE$ + $CRLF
         copyLog = copyLog + "AutoBackup time: " + TIME$ + $CRLF
         copyLog = copyLog + "AutoBackup File: " + thisFile + $CRLF 
         msgbox sCopyTo
         IF ISFOLDER(sCopyTo) = 0 THEN 'target is unavailable
            s = "Target folder not found" + $CRLF +"... This auto backup will be aborted"
            CONTROL SET TEXT CB.HNDL, %IDC_Done, s
            CONTROL SET TEXT CB.HNDL, %IDOK, "Ok"           
            copyLog = copyLog + s + $crlf
            EXIT FUNCTION
         END IF
         start = TIMER
         backupFiles
         'show the backup time ----------------------------------------------------------------
         t = TIMER - start
         hh = t\3600: mm = (t-3600*hh)\60: ss = t-3600*hh-60*mm
         if hh >= 1 then
            mm = mm + ss/60
            sTime = format$(hh,"0") + " hours and " + format$(mm,"0.00") + " minutes"
         elseif mm >= 1 then
            mm = mm + ss/60
            sTime = sTime + format$(mm,"0.00") + " minutes"
         elseif ss > 1 then
            sTime = sTime + format$(ss,"0") + " seconds"
         else
            sTime = "less than a second"   
         end if
         'display the results -----------------------------------------------------------------
         s1 = $crlf + "AutoBackup completed: "
         IF running = -2 THEN s1 = $crlf + "AutoBackup interrupted: "
         s = s1 + $CRLF + STR$(numFiles) + " files copied in " + sTime
         CONTROL SET TEXT hStatus, %IDC_Done, s
         CONTROL SET TEXT CB.HNDL, %IDOK, "Ok"
         copyLog = copyLog + $crlf + $crlf + s1 + $crlf
         copyLog = copyLog + STR$(numFiles) + " files copied in " + sTime + " to " + sCopyTo
         'print results of autoBackup to log file ------------------------------------------------
         logFile = FREEFILE
         OPEN dataFolder + "myBackup.log" FOR OUTPUT AS logFile
         print #logFile, copyLog
         CLOSE #logFile: running = -1
   END SELECT
END FUNCTION

SUB backupFiles()
   'copy files from multiple source folders to a single copyTo folder
   'copyTo = "F:\my Backup"
   'source = "C:\PBWin90
   'target = "F:\myBackup\PBWin90"
   '------------------------------------------------------------------------
   LOCAL i, n AS LONG
   LOCAL s AS STRING
   running = 1: numFiles = 0
   createFolder sCopyTo                       
   FOR i = 1 TO numSources
      IF running = 0 THEN running = -2: EXIT SUB 'auto backup interrupted
      sSource = sources(i)
      IF ISFOLDER(sSource) THEN
         CONTROL SET TEXT hStatus, %IDC_Done, "Backing up: " + sSource
         n = INSTR(sSource, "\"): s = MID$(sSource, n + 1)
         sTarget = sCopyTo + s               
         copyLog = copyLog + $crlf
         copyLog = copyLog + "**** " + sSource + $crlf
         copyDir sSource
      ELSE
         copyLog = copyLog + $crlf
         copyLog = copyLog + "*** Source not found: " + sSource + $crlf
      END IF
   NEXT i
   running = -1
END SUB

SUB copyDir(BYVAL sPath AS STRING)
   'recursively finds and copies all files in sSource to sTarget
   'first call is made without the flag
   'code by Casey Sprangel of www.ifxGroup.net, modified by Charles Dietz
   '------------------------------------------------------------------------
   local fileSize, big AS dword, p as double
   LOCAL s, s1, ssPath, sDateMod, sDateMod1, fn, f AS STRING
   LOCAL i, hSearch, hSrch, nErr AS LONG           'search handles
   LOCAL WFD, WFD1 AS WIN32_FIND_DATA              'find file data structure (WFD for source, WFD1 for target)
   LOCAL mask AS ASCIIZ * %MAX_PATH                'what to search for
   local folderX as long                           'folder exception
   dim buff(8192) as byte

   big = 10000000
   sPath = RTRIM$(sPath, "\") + "\"            'add backslash if not there
   ssPath = MID$(sPath, LEN(sSource) + 1)      'part of sPath extended by recursion
   createFolder sTarget + ssPath                                         
   mask = sPath + "*.*"                        'mask lists where and what files to find
   hSearch = FindFirstFile(mask, WFD)          'get handle of first file found
   IF hSearch <> %INVALID_HANDLE_VALUE THEN    'loop through directory for files
      DO
         IF BIT(WFD.dwFileAttributes, 4) THEN 'this is a folder
            folderX = 0
            IF WFD.cFileName <> "." AND WFD.cFileName <> ".." THEN
               s = rtrim$(LCASE$(sPath + WFD.cFileName), "\") + "\"
               FOR i = 1 TO numExcept
                  IF INSTR(s, except(i)) then folderX = 1: ITERATE DO
               NEXT i
               copyDir s
            END IF
         ELSE 'this is a file... it may need to be copied
            fn = WFD.cFileName
            sDateMod = getFileDateTime(WFD.ftLastWriteTime)
            'determine modify date of corresponding target file
            hSrch = FindFirstFile(sTarget + ssPath + fn, WFD1)
            IF (hSrch > 0) AND _
            ((WFD1.dwFileAttributes AND %FILE_ATTRIBUTE_DIRECTORY) <> %FILE_ATTRIBUTE_DIRECTORY) THEN
               sDateMod1 = getFileDateTime(WFD1.ftLastWriteTime)
            else
               sDateMod1 = "00000000"
            END IF
            'copy if backing-up file with later date, or restoring
            IF running AND ((sDateMod > sDateMod1)) THEN 'copy file
               fileSize = MAK(QUAD, WFD.nFileSizeLow, WFD.nFileSizeHigh) + clusterSize
               f = sPath + fn: s1 = ""
               if fileSize > big then
                  nErr = fileBlockCopy(f, sTarget + ssPath + fn, 65536)
                  if nErr = 0 then s1 = "API system error code = " + str$(GetLastError())
               else
                  FILECOPY f, sTarget + ssPath + fn
                  nErr = errclear
                  if nErr then s1 = "ERROR - " + ERROR$(nErr)
               end if
               'print results to myBackup.log ---------------------------------------------------
               IF len(s1) = 0 then 
                  sDateMod1 = ""
                  hSrch = FindFirstFile(sTarget + ssPath + fn, WFD1): FindClose hSrch
                  IF hSrch > 0 THEN sDateMod1 = getFileDateTime(WFD1.ftLastWriteTime)
                  IF LEN(sDateMod1) THEN 'copied to target
                     INCR numFiles: s1 = ""
                  ELSE 'not copied to target for some reason                          
                     s1 = "Error - unspecified reason"
                  END IF
               END IF
               copyLog = copyLog + f + $CRLF
               IF LEN(s1) THEN copyLog = copyLog + $CRLF + s1
            END IF
         END IF
      LOOP WHILE FindNextFile(hSearch, WFD)
   END IF
   FindClose hSearch
END SUB

function fileBlockcopy(sSource as string, sTarget as string, buffSize as dword) as dword
   'copies file in blocks using win32API... useful when needing more continuous status 
   'sSource: file to copy
   'sTarget: file target of copy
   'buffSize: size of blocks to copy (eg. 8192, 65536, 1000000)
   'returns bytes copied
   'returns -1 if sSource not found, -2 if sTarget folder not found
   '-------------------------------------------------------------------------------------------
   local fSource, fTarget as asciiz * 128
   local hSource, hTarget, hTemplateFile, totalBytes as dword
   local bytesRead, bytesWritten as dword, nErr as long
   local pBuff as byte ptr, psa as SECURITY_ATTRIBUTES ptr
   local ofs as OFSTRUCT  ', saStruct as SECURITY_ATTRIBUTES
   if isfile(sSource) = 0 then _
      function = -1: end
   if isfolder(pathname$(path, sTarget)) = 0 then _
      function = -2: end
   dim buff(buffSize) as byte
   fSource = sSource
   fTarget = sTarget
   hSource = openFile(fSource, ofs, %OF_READ)
   if hSource = 0 then exit function
   hTarget = createFile(fTarget, byval %GENERIC_WRITE, byval 0, byval psa, BYVAL %CREATE_ALWAYS, _
      BYVAL %FILE_ATTRIBUTE_NORMAL, byval htemplateFile)
   if hTarget = 0 then exit function
   pBuff = varptr(buff(0))
   do
      nErr = ReadFile(hSource, byval pBuff, buffSize, bytesRead, byval 0)
      if nErr = %FALSE then exit function
      if bytesRead > 0 then 
         nErr = WriteFile(hTarget, pBuff, bytesRead, bytesWritten, byval 0)
         if (nErr = %FALSE) or (bytesWritten = 0) then exit function
      end if
      totalBytes = totalBytes + bytesWritten
   loop while (bytesRead > 0) and (bytesRead = bytesWritten)
   _lclose(hSource)
   _lclose(hTarget)
   function = totalBytes
end function

SUB openTheFile()
   'get contents of backup configuration file
   LOCAL hFile, i, n AS LONG
   hFile = FREEFILE
   OPEN thisFile FOR BINARY AS #hFile
   GET #hFile,, numSources
   GET #hFile,, n: sCopyTo = SPACE$(n): GET #hFile,, sCopyTo
   REDIM sources(numSources)
   FOR i = 1 TO numSources
      GET #hFile,, n: sources(i) = SPACE$(n): GET #hFile,, sources(i)
   NEXT i
   n = SEEK(#hFile)
   seek #hFile, n + 4*numSources  'seek past lastDate()
   geT #hFile,, numExcept
   redim except(1 to numExcept)
   FOR i = 1 TO numExcept
      GET #hFile,, n: except(i) = SPACE$(n): GET #hFile,, except(i)
   NEXT i
   CLOSE #hFile
END SUB

SUB createFolder(BYVAL folder AS STRING)
   LOCAL i, n AS LONG
   LOCAL f, s, sNet AS STRING
   IF LEFT$(folder, 2) = "\\" THEN 'UNC network path
      sNet = "\\": folder = MID$(folder, 3)
   END IF                                                        
   n = PARSECOUNT(folder, "\")
   FOR i = 1 TO n
      f = PARSE$(folder, "\", i)
      IF LEN(f) THEN
         s = s + f + "\"
         IF ISFOLDER(s) = 0 THEN MKDIR sNet + s
      END IF
   NEXT i
END SUB

FUNCTION getFileDateTime(dt AS FILETIME) AS STRING
   'return string: year & month & day & hour & minute
   '------------------------------------------------------------------
   LOCAL lpsystime AS SYSTEMTIME
   LOCAL sDate AS ASCIIZ * 32 'date buffer
   LOCAL sTime AS ASCIIZ * 32 'time buffer

   'set the last modified date & time and the get the correct formats
   CALL FileTimeToLocalFileTime(dt, dt)
   CALL FileTimeToSystemTime(dt, lpsystime)

   CALL GetDateFormat (%LOCALE_SYSTEM_DEFAULT, %DATE_SHORTDATE, BYVAL VARPTR(lpsystime), _
                        BYVAL %NULL, sDate, 32)
   CALL GetTimeFormat (%LOCALE_SYSTEM_DEFAULT, %TIME_FORCE24HOURFORMAT OR %TIME_NOSECONDS, _
                        BYVAL VARPTR(lpsystime), BYVAL %NULL, sTime, 32)
   FUNCTION = PARSE$(sDate, "/", 3) _
            + RIGHT$("0" + PARSE$(sDate, "/", 1), 2) _
            + RIGHT$("0" + PARSE$(sDate, "/", 2), 2) _
            + RIGHT$("0" + PARSE$(sTime, ANY ": ", 1), 2) _
            + RIGHT$("0" + PARSE$(sTime, ANY ": ", 2), 2)
END FUNCTION

FUNCTION SpecialFolder(pidl AS DWORD) AS STRING
' by Wayne Diamond 12-03-01
' http://www.powerbasic.com/support/forums/Forum7/HTML/001233.html
'----------------------------------------------------------------------
   LOCAL TmpAsciiz AS ASCIIZ * %MAX_PATH
   CoInitialize BYVAL 0
   IF ISFALSE(SHGetSpecialFolderLocation(BYVAL %HWND_DESKTOP, BYVAL pidl, BYVAL VARPTR(pidl))) THEN
      SHGetPathFromIDList BYVAL pidl, TmpAsciiz
      CoTaskMemFree BYVAL pidl
   END IF
   CoUninitialize
   FUNCTION = TmpAsciiz
END FUNCTION

FUNCTION getProcID(progName AS STRING) AS DWORD
   'Enumerate Processes by Semen Matusovski
   'http://www.powerbasic.com/support/forums/Forum7/HTML/001497.html (08-03-2002)
   'return procID if found, otherwise return 0
   '=======================================================================================
   LOCAL hKernel32, hCreateToolhelp32Snapshot, hProcess32Next, hProcess32First AS DWORD
   LOCAL hModule32First, hModule32Next, hPsApiDll, hEnumProcesses, hProcessSnap AS DWORD
   LOCAL hGetModuleFileNameEx, hEnumProcessModules, nModules, cb, cbNeeded, i AS DWORD
   LOCAL nProcesses, hProcess, procID AS DWORD, lResult1 AS LONG, processName AS STRING
   LOCAL os AS OSVERSIONINFO, pe AS PROCESSENTRY32

   processName = LCASE$(progName)
   os.dwOSVersionInfoSize = SIZEOF(os)
   GetVersionEx BYVAL VARPTR(os)

   IF ISFALSE(os.dwPlatformId = %VER_PLATFORM_WIN32_NT) THEN 'Windows 95/98
      hKernel32                 = GetModuleHandle("kernel32.dll")
      hCreateToolhelp32Snapshot = GetProcAddress(hKernel32, "CreateToolhelp32Snapshot")
      hProcess32Next            = GetProcAddress(hKernel32, "Process32Next")
      hProcess32First           = GetProcAddress(hKernel32, "Process32First")              
      hModule32First            = GetProcAddress(hKernel32, "Module32First")
      hModule32Next             = GetProcAddress(hKernel32, "Module32Next")

      CALL DWORD hCreateToolhelp32Snapshot USING CreateToolhelp32Snapshot (%TH32CS_SNAPPROCESS, 0&) TO hProcessSnap
      IF hProcessSnap <> %INVALID_HANDLE_VALUE THEN
         pe.dwSize = SIZEOF(pe)
         CALL DWORD hProcess32First USING Process32First (hProcessSnap, pe) TO lResult1
         DO WHILE lResult1
            IF INSTR(LCASE$(pe.szExeFile), processName) THEN
               procID = pe.th32ProcessID: EXIT DO
            END IF
            CALL DWORD hProcess32Next USING Process32Next (hProcessSnap, pe) TO lResult1
         LOOP
         CloseHandle hProcessSnap
     END IF

   ELSE ' Windows NT
      hPsApiDll = GetModuleHandle("psApi.dll")
      IF hPsApiDll = 0 THEN hPsApiDll = LoadLibrary("psApi.dll")
      hEnumProcesses       = GetProcAddress(hPsApiDll, "EnumProcesses")
      hGetModuleFileNameEx = GetProcAddress(hPsApiDll, "GetModuleFileNameExA")
      hEnumProcessModules  = GetProcAddress(hPsApiDll, "EnumProcessModules")

      cb = 100
      DO
         REDIM ProcessIDs(1 TO cb \ 4) AS DWORD
         CALL DWORD hEnumProcesses USING EnumProcesses (ProcessIDs(1), cb, cbNeeded) TO lResult1
         IF cb > cbNeeded THEN EXIT DO ELSE cb = cb + cb
      LOOP
      nProcesses = cbNeeded \ 4
      FOR i = 1 TO nProcesses
         hProcess = OpenProcess(%PROCESS_QUERY_INFORMATION OR %PROCESS_VM_READ, %False, ProcessIDs(i))
         IF hProcess THEN
            cb = 100
            DO
               REDIM Modules(1 TO cb / 4) AS DWORD
               CALL DWORD hEnumProcessModules USING EnumProcessModules (hProcess, Modules(1), cb, cbNeeded) TO lResult1
               IF lResult1 = 0 THEN cbNeeded = 0: ITERATE FOR
               IF cb > cbNeeded THEN EXIT DO ELSE cb = cb + cb
            LOOP
            nModules = cbNeeded / 4
            CALL DWORD hGetModuleFileNameEx USING GetModuleFileNameEx (hProcess, Modules(1), pe.szExeFile, SIZEOF(pe.szExeFile)) TO lResult1
            CloseHandle hProcess
            IF INSTR(LCASE$(pe.szExeFile), processName) THEN
               procID = ProcessIDs(i): EXIT FOR
            END IF
         END IF
      NEXT
   END IF
   FUNCTION = procID
END FUNCTION
