#COMPILE EXE
#DIM ALL
#INCLUDE "wIN32api.inc"
global shutDownOk as long

FUNCTION PBMAIN()
   LOCAL tq AS QUAD
   LOCAL sleepSeconds, validPriv, hThread, logFile, origState, n AS LONG
   LOCAL htimer AS dword
   origState = SetThreadExecutionState(%ES_CONTINUOUS)
   sleepSeconds = 90  '150  
   validPriv = EnableShutDownPriv()           
   if validPriv = 0 then
      msgbox "Necessary privilege not available", , "Enable Shut Down": exit function
   end if
   htimer = CreateWaitableTimer(BYVAL %NULL, 1, "AutoBackupTimer")
   if htimer = 0 then
      msgbox "Timer could not be created", , "Set Waitable Timer": exit function
   end if
   'waitable timer: time in 100 nanosecond intervals (neg for relative time)
   tq = -10000000 * sleepSeconds
   n = SetWaitableTimer(BYVAL htimer, tq, 0, BYVAL %NULL, BYVAL %NULL, 1)
   if n = 0 then
      msgbox "Timer could not be set", , "Set Waitable Timer": exit function
   end if
   if GetLastError() = %ERROR_NOT_SUPPORTED THEN
      MSGBOX "ERROR NOT SUPPORTED",, "Set Waitable Time": exit function
   end if
   shutDownOk = 0
   thread create ShutDownProc(varptr(hTimer)) to hThread
   if hThread = 0 then
      CloseHandle htimer
      msgbox "Could not create thread": exit function
   end if
   while shutDownOk = 0: wend
   thread close hThread to n
   SetSystemPowerState(byval 0, byval 0)
   'now for the backup code ---------------------------------------------------------
   OPEN "WakeupTest.log" FOR OUTPUT AS logFile
   PRINT #logFile, "Wakeup test date: " + DATE$
   PRINT #logFile, "Wakeup test time: " + TIME$
   PRINT #logFile, ""
   CLOSE #logFile
   waitSeconds 15
   msgbox "Computer has awakened!"
   SetThreadExecutionState(origState)
END FUNCTION

sub waitSeconds(t as long)
   local t0 as long
   t0 = timer
   while timer - t0 < t
   wend
end sub

function EnableShutDownPriv() as long
   local hProcess, token, luid, n as long
   local priv as TOKEN_PRIVILEGES
   hProcess = GetCurrentProcess()
   n = OpenProcessToken(hProcess, %TOKEN_ADJUST_PRIVILEGES or %TOKEN_QUERY, token)
   if n = 0 then function = 0
   LookupPrivilegeValue(byval %NULL, "SeShutdownPrivilege", varPtr(luid))
   priv.PrivilegeCount = 1
   priv.Privileges(0).Attributes = %SE_PRIVILEGE_ENABLED
   priv.Privileges(0).Luid = luid
   AdjustTokenPrivileges(byval token, byval 0, varptr(priv), byval 0, byval %NULL, byval %NULL)
   CloseHandle(token)
   function = 1
end function

thread function ShutDownProc(byval pTimer as dword ptr) as dword
   WaitForSingleObject BYVAL @pTimer, %INFINITE
   CloseHandle @pTimer
   shutDownOk = 1
end function

