#COMPILE EXE
#DIM ALL
#INCLUDE "wIN32api.inc"
#INCLUDE "debug.inc"

%LB_SETHORIZONTALEXTENT= &H194
%ID_Find      = 101
%ID_SrchList  = 102
%ID_AddSrch   = 103
%ID_Begin     = 104
%ID_Reset     = 105
%ID_FoundList = 201

global hDlg, hShow, nFound as long
global sFind as string
global foundItems() as string

FUNCTION PBMAIN()
   local nStyle as long
   DIALOG NEW 0, "Find Matching Files and Folders", , , 240, 200, %WS_SYSMENU TO hDlg
   control add label, hDlg, -1, "Find: ", 20, 15, 25, 12
   control add textbox, hDlg, %ID_Find, "", 40, 15, 90, 12
   nStyle = %WS_VSCROLL or %WS_BORDER
   CONTROL ADD LISTBOX, hDlg, %ID_SrchList, , 20, 40, 160, 100, nStyle, %WS_EX_CLIENTEDGE 
   control add button, hDlg, %ID_AddSrch, "&Add search folder", 5, 150, 65, 20
   control add button, hDlg, %ID_Begin, "&Begin search", 75, 150, 65, 20
   control add button, hDlg, %ID_Reset, "&Reset", 145, 150, 65, 20
   DIALOG SHOW MODAL hDlg, CALL mainDlgProc
END FUNCTION

CALLBACK FUNCTION mainDlgProc()
   local s, srch as string
   SELECT CASE CBMSG
      CASE %WM_COMMAND
         if cb.ctl = %ID_AddSrch then
            IF CB.CTLMSG = %BN_CLICKED OR CB.CTLMSG = 1 THEN
               s = "Choose folder to search"
               DISPLAY BROWSE CB.HNDL, , , s, "C:\", %BIF_NEWDIALOGSTYLE TO srch
               IF LEN(srch) THEN 'adding a folder to search
                  nFound = 0
                  srch = RTRIM$(srch, "\") + "\"
                  listbox add cb.hndl, %ID_SrchList, srch
               END IF
            END IF
         elseif cb.ctl = %ID_Find AND CB.CTLMSG = %EN_CHANGE THEN
            nFound = 0   
         elseIF CBCTL = %ID_Begin then
            control get text cb.hndl, %ID_Find to sFind
            showFiles
         elseif cbctl = %ID_Reset then
            nFound = 0
         end if
   end select            
end function 


sub showFiles()
   local nStyle as long
   DIALOG NEW 0, "Find Matching Files and Folders", , , 400, 300, %WS_SYSMENU TO hShow
   nStyle = %WS_VSCROLL or %WS_HSCROLL or %WS_BORDER
   CONTROL ADD LISTBOX, hShow, %ID_FoundList, , 20, 10, 360, 260, nStyle, %WS_EX_CLIENTEDGE
   control send hShow, %ID_FoundList, %LB_SETHORIZONTALEXTENT, 600, 0
   control send hShow, %ID_FoundList, %LBS_DISABLENOSCROLL , 0, 0 
   DIALOG SHOW MODAL hShow, CALL showFilesProc
end sub

CALLBACK FUNCTION showFilesProc()
   local i, nCount as long
   local sPath as string
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         DIALOG POST CB.HNDL, %WM_COMMAND, %IDOK, 0
      CASE %WM_COMMAND
         IF CBCTL = %IDOK then
            listbox get count hDlg, %ID_SrchList to nCount
            for i = 1 to nCount
               listbox get text hDlg, %ID_SrchList, i to sPath
               myFindFiles sPath
            next i
            if nFound then
               redim foundItems(nFound)
               for i = 1 to nFound
                  listbox get text hShow, %ID_FoundList, i to foundItems(i)
               next i 
            else         
               listbox add hShow, %ID_FoundList, "None found"
            end if
         end if
   end select            
end function 

sub myFindFiles(sPath AS STRING)
   'recursively finds and display files matching sFind, starting from sPath
   'first call is made without the flag
   'code by Casey Sprangel of www.ifxGroup.net, modified by Charles Dietz
   '--------------------------------------------------------------------------------
   local s, ss, fn as string
   local hSearch as long
   LOCAL WFD, WFD1 AS WIN32_FIND_DATA          'find file data structure (WFD for source, WFD1 for target)
   LOCAL mask AS ASCIIZ * %MAX_PATH            'what to search for

   sPath = RTRIM$(sPath, "\") + "\"            'add backslash if not there
   mask = sPath + "*.*"                        'mask lists where and what files to find
   hSearch = FindFirstFile(mask, WFD)          'get handle of first file found
   IF hSearch <> %INVALID_HANDLE_VALUE THEN    'loop through directory for files
      DO
         IF BIT(WFD.dwFileAttributes, 4) THEN 'this is a folder
            IF WFD.cFileName <> "." AND WFD.cFileName <> ".." THEN
               s = rtrim$(LCASE$(sPath + WFD.cFileName), "\") + "\"
               if instr(s, sFind) then
                  incr nFound: foundItems(nFound) = s
                  listbox add hShow, %ID_FoundList, s
               end if
               myFindFiles s
            END IF
         ELSE 'this is a file... it may need to be copied
            fn = WFD.cFileName
            s = sPath + fn
            if instr(s, sFind) then
               incr nFound: foundItems(nFound) = s
               listbox add hShow, %ID_FoundList, s
            end if
         END IF
      LOOP WHILE FindNextFile(hSearch, WFD)
   END IF
   FindClose hSearch
END sub
