'appHelp 1.00
'                                                                            
'This include file displays a file created with NoteKeeper
' 
'uses a Treeview control to display headings, topics, and content
'use NoteKeeper to prepare help file e.g. "myHelp.nkp"
'just call the NoteKeeper file from your program: appHelp("myHelp.nkp", title)
'title is optional, and if not specified, defaults to "Application Help"
'
'Strategy employed when created, was that titles() items could be rearranged for
'insertions, but texts() items should not be moved, since they can be very large
'therefore, pointers to texts() items are employed, but not to titles()
'--------------------------------------------------------------------------------

%IDC_appHelp_Treeview  = 101
%IDC_appHelp_Title     = 102
%IDC_appHelp_Textbox   = 103
%IDC_appHelp_Splitbar  = 104
%IDC_appHelp_PrintItem = 105

global appHelp_hDlg         as long    'help dialog
global appHelp_NumTree      as long    'number of tree items
GLOBAL appHelp_Titles()     as string  'titles of tree items
global appHelp_Texts()      AS STRING  'text for tree items
global appHelp_treeLevel()  as long    'level = 0 for topic and 1 for note
global appHelp_Indexes()    as long    'indexes (sequenced only if not out of sort)
global appHelp_Index        as long    'index for last tree item selected
global appHelp_hItem        as long    'saved handle to last selected item               
global appHelp_wChar        as double  'header-line char width ("-")
global appHelp_x            as long    'specified window x pixel position 
global appHelp_y            as long    'specified window y pixel position

sub appHelp(helpFile as string, opt byval title as string, byval x as long, byval y as long) 
   LOCAL nStyle AS DWORD
   appHelp_x = x: appHelp_y = y
   nStyle = %WS_THICKFRAME OR %WS_SYSMENU OR %WS_MINIMIZEBOX
   if len(title) = 0 then title = "Application Help"
   DIALOG NEW PIXELS, 0, title, , , 640, 370, nStyle TO appHelp_hDlg                            
   nStyle = %TVS_HASLINES OR %TVS_HASBUTTONS OR %TVS_LINESATROOT OR %WS_TABSTOP
   CONTROL ADD TREEVIEW, appHelp_hDlg, %IDC_appHelp_Treeview, "", 10, 5, 235, 325, nStyle
   control add label, appHelp_hDlg, %IDC_appHelp_Title, "", 250, 5, 355, 23
   control set color appHelp_hDlg, %IDC_appHelp_Title, %RGB_BLACK, %RGB_LIGHTGRAY
   nStyle = %ES_AUTOVSCROLL OR %WS_VSCROLL OR %ES_MULTILINE OR %ES_READONLY OR %WS_TABSTOP
   CONTROL ADD TEXTBOX, appHelp_hDlg, %IDC_appHelp_Textbox, "", 250, 30, 370, 300, nStyle
   control set color appHelp_hDlg, %IDC_appHelp_Textbox, %RGB_BLACK, %RGB_white
   CONTROL ADD LINE, appHelp_hDlg, %IDC_appHelp_Splitbar, "", 245, 5, 5, 325, %SS_NOTIFY
   control add button, appHelp_hDlg, %IDC_appHelp_PrintItem, "Print this item", 320, 330, 100, 30
   dialog set user appHelp_hDlg, 1, strptr(helpFile)
   DIALOG SHOW MODAL appHelp_hDlg, CALL appHelpProc
eND sub

CALLBACK FUNCTION appHelpProc()
   LOCAL iRet, w, v, dx, i, n, hFile, nStyle AS LONG                          
   LOCAL hFont, hTextbox AS DWORD, k as word, tabSpace as dword 
   local s AS STRING                                                   
   local helpFile as asciiz ptr
   local t AS SIZEL
   LOCAL pNMHDR AS NMHDR PTR, pt AS POINTAPI
   STATIC wi, ht, x, y, x1, x2, w1, w2, u, h, yy, hh, hdc AS LONG
   STATIC splitting, hItem, index, wTextBox AS LONG
   static wChar as double
   static sItem as string
   SELECT CASE CB.MSG
      CASE %WM_INITDIALOG
         dialog get user cb.hndl, 1 to helpFile                           
         if appHelp_index then
            appHelp_Treeview()
            hItem = appHelp_hItem
            TREEVIEW GET USER appHelp_hDlg, %IDC_AppHelp_Treeview, hItem to index
            CONTROL SET TEXT CB.HNDL, %IDC_appHelp_Title, appHelp_Titles(index)
            CONTROL SET TEXT CB.HNDL, %IDC_appHelp_Textbox, appHelp_Texts(index)
            TREEVIEW SELECT cb.hndl, %IDC_appHelp_Treeview, hItem
            TREEVIEW GET PARENT cb.hndl, %IDC_appHelp_Treeview, hItem TO h  'get parent of hItem
            TREEVIEW SET EXPANDED cb.hndl, %IDC_appHelp_Treeview, h, 1      'expand the parent
         else
            'open and read the help file
            hFile = FREEFILE: s = @helpFile
            OPEN s FOR BINARY AS hFile
            GET hFile,, n: appHelp_numTree = ABS(n)
            if appHelp_numTree = 0 then
               msgbox "No help available",%MB_ICONinformation, "Help File"
               close hFile: dialog end cb.hndl: exit function
               'dialog send cb.hndl, %WM_SYSCOMMAND, %SC_CLOSE, 0
               'EXIT FUNCTION 
               'DIALOG END CB.HNDL: exit function                      
            end if
            
            'read in the help file        
            REDIM appHelp_Texts(1 TO appHelp_numTree)
            REDIM appHelp_Titles(1 TO appHelp_numTree)
            redim appHelp_TreeLevel(1 to appHelp_numTree)
            redim appHelp_Indexes(1 to appHelp_numTree)
            FOR i = 1 TO appHelp_numTree
               GET hFile,, k: appHelp_Texts(i) = SPACE$(k)
               GET hFile,, appHelp_Texts(i)
            NEXT i
            FOR i = 1 TO appHelp_numTree
               GET hFile,, k: appHelp_Titles(i) = SPACE$(k)
               GET hFile,, appHelp_Titles(i)
            NEXT i
            get hFile,, appHelp_TreeLevel() 
            get hFile,, appHelp_Indexes()
            CLOSE hFile                                                          
            appHelp_Treeview()
            
            'select first item
            treeview get root CB.HNDL, %IDC_appHelp_Treeview to hItem
            TREEVIEW SELECT CB.HNDL, %IDC_appHelp_Treeview, hItem              
            TREEVIEW GET USER CB.HNDL, %IDC_appHelp_Treeview, hItem TO index
            TREEVIEW GET text CB.HNDL, %IDC_appHelp_Treeview, hItem TO s
            control set text cb.hndl, %IDC_appHelp_Title, space$(5) + s
            CONTROL SET TEXT CB.HNDL, %IDC_appHelp_Textbox, appHelp_Texts(index)
         end if              
         
         
         'set styles and fonts                                      
         FONT NEW "MS Sans Serif", 12 TO hFont
         CONTROL SET FONT cb.hndl, %IDC_appHelp_Title, hFont
         FONT NEW "MS Sans Serif", 10 TO hFont                                    
         CONTROL SET FONT cb.hndl, %IDC_appHelp_Textbox, hFont          
         CONTROL SET FONT cb.hndl, %IDC_appHelp_Treeview, hFont
         nStyle = %EC_LEFTMARGIN or %EC_RIGHTMARGIN
         CONTROL SEND cb.hndl, %IDC_appHelp_Textbox, %EM_SETMARGINS, nStyle, MAK(DWORD, 12, 12)
         control handle CB.HNDL, %IDC_appHelp_Textbox to hTextbox
      CASE %WM_SIZE                                                             
          'resize controls 
         if appHelp_x or appHelp_y then 'reset loc only if user specifies the loc
            dialog set loc cb.hndl, appHelp_x, appHelp_y
         end if
         DIALOG GET CLIENT CB.HNDL TO wi, ht                                                                  
         CONTROL GET SIZE CB.HNDL, %IDC_appHelp_Treeview TO w, h
         CONTROL GET LOC  CB.HNDL, %IDC_appHelp_SplitBar TO x, y
         CONTROL SET SIZE CB.HNDL, %IDC_appHelp_Title, wi - x - 35, y + 18
         CONTROL SET SIZE CB.HNDL, %IDC_appHelp_Textbox, wi - x - 20, ht - 85
         CONTROL SET SIZE CB.HNDL, %IDC_appHelp_Treeview, w, ht - 60
         CONTROL SET SIZE CB.HNDL, %IDC_appHelp_SplitBar, 5, ht - 60
         DIALOG PIXELS CB.HNDL, (wi-x-20)/8, 0 TO UNITS tabSpace, y
         SendMessage hTextbox, %EM_SETTABSTOPS, 1, VARPTR(tabSpace)
      CASE %WM_SetCursor
         'show horizontal arrows if cursor is over splitter control
         iRet = GetDlgCtrlID (CB.WPARAM)
         IF iRet = %IDC_appHelp_SplitBar THEN MOUSEPTR 9: FUNCTION = 1
         'monitors the 3 basic splitter bar mouse actions, lbuttondown, mousemove, lbuttonup
         SELECT CASE HI(WORD, CB.LPARAM)
            CASE %WM_LBUTTONDOWN
               'sets flag to say splitter action has started (no actual movement yet)
               IF iRet = %IDC_appHelp_SplitBar THEN
                  Splitting = 1
                  CONTROL GET LOC  CB.HNDL, %IDC_appHelp_Treeview  TO x1, y
                  CONTROL GET SIZE CB.HNDL, %IDC_appHelp_Treeview  TO w1, h
                  CONTROL GET LOC  CB.HNDL, %IDC_appHelp_Textbox  TO x2, yy
                  CONTROL GET SIZE CB.HNDL, %IDC_appHelp_Textbox  TO w2, hh                   
                  CONTROL GET LOC  CB.HNDL, %IDC_appHelp_SplitBar  TO u, v: x = u
               END IF
            CASE %WM_MOUSEMOVE
               'resizes windows and moves splitter bar to match mouse position (if position has changed)
               IF splitting THEN
                  GetCursorPos pt               'pt has xy screen coordinates in pixels
                  ScreenToClient CB.HNDL, pt    'pt now has client coordinates in pixels
                  IF pt.x <> x THEN             'mouse position has changed... resize
                     dx = pt.x - x
                     CONTROL SET LOC  CB.HNDL, %IDC_appHelp_Treeview, x1, y                             
                     CONTROL SET SIZE CB.HNDL, %IDC_appHelp_Treeview, w1 + dx, h

                     CONTROL SET LOC  CB.HNDL, %IDC_appHelp_Title, x2 + dx, y
                     CONTROL SET SIZE CB.HNDL, %IDC_appHelp_Title, w2 - dx - 15, 23
                     
                     CONTROL SET LOC  CB.HNDL, %IDC_appHelp_Textbox, x2 + dx, y + 23
                     CONTROL SET SIZE CB.HNDL, %IDC_appHelp_Textbox, w2 - dx, h - 23
                     CONTROL SET LOC  CB.HNDL, %IDC_appHelp_SplitBar, u + dx, y
                  END IF                                                                           
               END IF
            CASE %WM_LBUTTONUP
               'sets flag to say splitter action has ended
               Splitting = 0
         END SELECT     
     CASE %WM_NOTIFY 
         IF CB.NMID = %IDC_appHelp_Treeview THEN
            pNMHDR = CB.NMHDR                                                   
            IF @pNMHDR.code = %TVN_SELCHANGEDW THEN
               'directed here when treeview selection changes
               TREEVIEW GET SELECT CB.HNDL, %IDC_appHelp_Treeview TO hItem
               TREEVIEW GET USER appHelp_hDlg, %IDC_appHelp_Treeview, hItem TO index 
               TREEVIEW GET parent CB.HNDL, %IDC_appHelp_Treeview, hItem to n
               treeview get text CB.HNDL, %IDC_appHelp_Treeview, hItem to sItem
               TREEVIEW GET USER CB.HNDL, %IDC_appHelp_Treeview, hItem TO index
               control set focus cb.hndl, %IDC_appHelp_Treeview
               CONTROL SET TEXT CB.HNDL, %IDC_appHelp_Title, appHelp_Titles(index)
               CONTROL SET TEXT CB.HNDL, %IDC_appHelp_Textbox, appHelp_Texts(index)
            END IF
         END IF
      CASE %WM_COMMAND
         SELECT CASE CB.CTL 
            CASE %IDC_appHelp_Textbox 'no need to be here
               IF CB.CTLMSG = %EN_SETFOCUS THEN
                  control set focus CB.HNDL, %IDC_appHelp_Treeview
               END IF
            case %IDC_appHelp_PrintItem
               if cb.ctlmsg = %BN_CLICKED then
                  if len(appHelp_Texts(index)) then appHelp_PrintItem
               end if
         end select
      CASE %WM_SYSCOMMAND 
         msgbox "here"                                           
         IF CB.CTL = %SC_CLOSE THEN 
            MSGBOX "HERE"
             if index then appHelp_index = index  'for calling help again later
         end if                                                            
   end select  
end function

SUB appHelp_TreeView()
   LOCAL hTopic, hNote, hItem, hFirst, index, i, j, k, h AS LONG
   LOCAL s AS STRING                                
   TREEVIEW RESET appHelp_hDlg, %IDC_AppHelp_Treeview
   FOR i = 1 TO appHelp_numTree
      index = appHelp_Indexes(i)
      j = appHelp_treeLevel(index)
      s = appHelp_Titles(index)
      IF j THEN 'treeview item is a note
         TREEVIEW INSERT ITEM appHelp_hDlg, %IDC_AppHelp_Treeview, hTopic, %TVI_LAST, 0, 0, s TO hNote
         TREEVIEW SET USER appHelp_hDlg, %IDC_AppHelp_Treeview, hNote, appHelp_Indexes(i)
         hItem = hNote
      ELSE 'treeview item is a topic                                                                   
         TREEVIEW INSERT ITEM appHelp_hDlg, %IDC_AppHelp_Treeview, 0, %TVI_LAST, 0, 0, s TO hTopic
         TREEVIEW SET USER appHelp_hDlg, %IDC_AppHelp_Treeview, hTopic, appHelp_Indexes(i)
         hItem = hTopic
      END IF
      'select same item as previous help call
      if index = appHelp_index then appHelp_hItem = hItem 
   NEXT i                                                       
   hItem = k                                      
END SUB

SUB appHelp_printItem()
   LOCAL m, n, k, i, j, mm, nLines, maxLines as long
   local tabCount, pgNo, multPgs, prn, hItem, index AS LONG
   LOCAL printerName, title, sTxt, s, sItem, temp, tabStr() AS STRING
   LOCAL leftMargin, topMargin, rightMargin, bottomMargin, pageWidth, pageHeight AS DOUBLE
   LOCAL x, wi, charHt, maxWidth AS DOUBLE
   LOCAL oTPrint AS iTPrint
   TREEVIEW GET select appHelp_hDlg, %IDC_appHelp_Treeview to hItem
   TREEVIEW GET USER appHelp_hDlg, %IDC_appHelp_Treeview, hItem TO index
   TREEVIEW GET TEXT appHelp_hDlg, %IDC_appHelp_Treeview, hItem TO title
   LET oTPrint = CLASS "cTPrint"
   printerName = oTPrint.choosePrinter
   IF LEN(printerName) = 0 THEN EXIT SUB
   leftMargin = .75: topMargin = .25: rightMargin = .75: bottomMargin = .50
   oTPrint.setMargins(leftMargin, rightMargin, topMargin, bottomMargin)
   oTPrint.getPageSize(pageWidth, pageHeight)
   maxWidth = pageWidth - leftMargin - rightMargin
   oTPrint.newFont("Courier New", 10)
   sTxt = appHelp_Texts(index)
   maxLines = oTPrint.getLines: n = 1: nLines = 4
   IF oTPrint.duplexSet THEN
      GOSUB printPages: multPgs = ABS(multPgs) 'test for multiple pages
      oTPrint.duplexPrint(multPgs + 1)
   END IF
   prn = 1
   wi = oTPrint.getTextWidth("Page 1")
   oTPrint.beginDoc("appHelp")

   oTPrint.beginPage
   oTPrint.newFont("Courier New", 12, "u")
   oTPrint.printText(title, leftMargin, topMargin)
   oTPrint.newFont("Courier New", 10)
   oTPrint.printText("Page 1", pageWidth - rightMargin - wi, topMargin)
   oTPrint.getCharSize(x, charHt)
   oTPrint.setPos(leftMargin, 4 * charHt)

   n = 1: nLines = 4: pgNo = 1
   GOSUB printPages
   oTPrint.closePage
   oTPrint.closeDoc
   EXIT SUB

   printPages:
      DO
         k = INSTR(n, sTxt, CHR$(13, 10))
         IF k THEN
            temp = MID$(sTxt, n, k - n): INCR k
         ELSE
            temp = MID$(sTxt, n): k = LEN(sTxt)
         END IF

         tabCount = PARSECOUNT(temp, CHR$(9))
         IF tabCount > 1 THEN 'process tabs
            REDIM tabStr(1 TO tabCount)
            PARSE temp, tabStr(), CHR$(9)
            temp = ""
            FOR i = 1 TO tabCount - 1
               s = SPACE$(8)
               j = 8 - (LEN(tabStr(i)) MOD 8)
               IF j THEN s = SPACE$(j)
               temp = temp + tabStr(i) + s
            NEXT i
            temp = temp + tabStr(tabCount)
         END IF

         x = oTPrint.getTextWidth(temp)
         IF x <= maxWidth THEN 'print the line
            IF prn THEN oTPrint.printText(temp)
            INCR nLines
         ELSE 'else temp is too long... must break into lines
            DO
               s = oTPrint.truncate(temp, maxWidth)
               m = INSTR(-1, s, ANY " -,;:.()[]{}<>~/|\=")
               mm = INSTR(MID$(s, m, 1), ANY "([{<")
               IF prn THEN oTPrint.printText(TRIM$(LEFT$(temp, m - mm)))
               temp = MID$(temp, m - mm + 1): INCR nLines
               IF nLines > maxLines THEN GOSUB appHelp_nextPage
            LOOP WHILE m
         END IF
         IF nLines > maxLines THEN GOSUB appHelp_nextPage
         n = k + 1
      LOOP WHILE n < LEN(sTxt)
      RETURN

   appHelp_nextPage: 
      'print header for page
      IF multPgs <= 0 THEN multPgs = -1: RETURN
      oTPrint.closePage
      oTPrint.beginPage
      nLines = 4: INCR pgNo
      wi = oTPrint.getTextWidth("Page" + STR$(pgNo))
      oTPrint.newFont("Courier New", 12, "u")
      oTPrint.printText(title, leftMargin, topMargin)
      oTPrint.newFont("Courier New", 10)
      oTPrint.printText("Page" + STR$(pgNo), pageWidth - rightMargin - wi, topMargin)
      oTPrint.setPos(leftMargin, 4 * charHt)
      RETURN
END SUB
