#COMPILE EXE
#DIM ALL
'#INCLUDE "autoBackupAPI.inc"
#INCLUDE "WIN32API.INC"
'#INCLUDE "debug.inc"

%IDC_Start  = 101
%IDC_Done   = 102
%IDC_Stop   = 103
%IDC_Timer  = 200

GLOBAL hMain, hStatus, running, autoInterval AS LONG
GLOBAL numSources, numFiles, numExcept, logFile, nErr AS LONG
GLOBAL dataFolder, thisFile, sSource, sources() AS STRING
GLOBAL sCopyTo, sTarget, sAutoFile, nextBackup AS STRING
global except() as string

'killProcess types
%TH32CS_SNAPPROCESS = &H2
%MAX_MODULE_NAME32 = 255
TYPE PROCESSENTRY32
   dwSize               AS DWORD
   cntUsage             AS DWORD
   th32ProcessID        AS DWORD                              ' This process
   th32DefaultHeapID    AS LONG PTR
   th32ModuleID         AS DWORD                              ' Associated exe
   cntThreads           AS DWORD
   th32ParentProcessID  AS DWORD                              ' This process's parent process
   pcPriClassBase       AS LONG                               ' Base priority of process threads
   dwFlags              AS DWORD
   szExeFile            AS ASCIIZ * %MAX_PATH                 ' Path
END TYPE

TYPE MODULEENTRY32
   dwSize               AS DWORD
   th32ModuleID         AS DWORD                              ' This module
   th32ProcessID        AS DWORD                              ' Owning process
   GlblcntUsage         AS DWORD                              ' Global usage count on the module
   ProccntUsage         AS DWORD                              ' Module usage count in th32ProcessID's context
   modBaseAddr          AS BYTE PTR                           ' Base address of module in th32ProcessID's context
   modBaseSize          AS DWORD                              ' Size in bytes of module starting at modBaseAddr
   hModule              AS DWORD                              ' The hModule of this module in th32ProcessID's context
   szModule             AS ASCIIZ * (%MAX_MODULE_NAME32 + 1)
   szExePath            AS ASCIIZ * %MAX_PATH
END TYPE

DECLARE FUNCTION CreateToolhelp32Snapshot (BYVAL dwFlags AS DWORD, BYVAL th32ProcessID AS DWORD) AS LONG
DECLARE FUNCTION Process32First           (BYVAL hSnapshot AS DWORD, pe AS PROCESSENTRY32)  AS LONG
DECLARE FUNCTION Process32Next            (BYVAL hSnapshot AS DWORD, pe AS PROCESSENTRY32)  AS LONG
DECLARE FUNCTION Module32First            (BYVAL hSnapshot AS DWORD, ME AS MODULEENTRY32)   AS LONG
DECLARE FUNCTION Module32Next             (BYVAL hSnapshot AS DWORD, ME AS MODULEENTRY32)   AS LONG
DECLARE FUNCTION EnumProcesses            (idProcess AS DWORD, BYVAL cb AS DWORD, cbNeeded AS DWORD) AS LONG
DECLARE FUNCTION GetModuleFileNameEx      (BYVAL hProcess AS DWORD, BYVAL hModule AS DWORD, ModuleName AS ASCIIZ, BYVAL nSize AS DWORD) AS DWORD
DECLARE FUNCTION EnumProcessModules       (BYVAL hProcess AS DWORD, hModule AS DWORD, BYVAL cb AS DWORD, cbNeeded AS DWORD) AS LONG

FUNCTION PBMAIN()
   LOCAL hMutex AS LONG
   IF alreadyRunning(hMutex, "my AutoBackup") THEN
      MSGBOX "autoBackup.exe is already loaded", %MB_ICONINFORMATION, "Auto Backup"
      EXIT FUNCTION
   END IF
   DIALOG NEW 0, "Auto Backup", , , 0, 0 TO hMain
   DIALOG SHOW STATE hMain, %SW_HIDE
   DIALOG SHOW MODAL hMain CALL mainProc
END FUNCTION

CALLBACK FUNCTION mainProc()
   LOCAL m, n, hFile, nDate, nNext AS LONG
   LOCAL day, mo, yr, maxDays AS LONG
   LOCAL t AS DOUBLE
   LOCAL s, sAutoBegin, sInterval AS STRING
   STATIC runNow, wait AS LONG
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         'define Windows data folder
         dataFolder = specialFolder(%CSIDL_COMMON_APPDATA)
         IF LEN(dataFolder) = 0 THEN dataFolder = "C:\My Documents\"
         dataFolder = dataFolder + "\cgdSoftware\myBackup\"
         IF ISFOLDER(dataFolder) = 0 THEN createFolder dataFolder
         sAutoFile = dataFolder + "autoBackup"
         'the file named "autoBackup" defines which backup file to run and when
         'open autoBackup file -----------------------------------------------------------
         IF ISFILE(sAutoFile) THEN
            hFile = FREEFILE
            OPEN sAutoFile FOR BINARY AS #hFile
            GET #hFile,, n: thisFile = SPACE$(n): GET #hFile,, thisFile
            GET #hFile,, autoInterval
            nextBackup = SPACE$(10): GET #hFile,, nextBackup
            CLOSE #hFile
         ELSE
            MSGBOX "AutoBackup file not found", %MB_ICONERROR, "Auto Backup Error"
            DIALOG END CB.HNDL: EXIT FUNCTION
         END IF
         IF ISFILE(thisFile) = 0 THEN 'check for backup definition file
            MSGBOX thisFile + " file not found", %MB_ICONERROR, "Auto Backup Error"
            DIALOG END CB.HNDL: EXIT FUNCTION
         END IF
         runNow = 1: wait = 1
         nNext = VAL(MID$(nextBackup, 7) + MID$(nextBackup, 1, 2) + MID$(nextBackup, 4, 2))
         nDate = VAL(MID$(DATE$, 7) + MID$(DATE$, 1, 2) + MID$(DATE$, 4, 2))
         IF nDate > nNext OR (nDate = nNext AND TIME$ > "00:02:00") THEN
            s = "AutoBackup was scheduled to have already run..." + $CRLF _
              + "Do you want to run it now?
            n = MSGBOX(s, %MB_ICONQUESTION OR %MB_YESNO, "Run AutoBackup")
            IF n = %IDNO THEN runNow = 0
            wait = 0: DIALOG POST CB.HNDL, %WM_USER + 100, 0, 0
         END IF
         n = autoInterval
         sInterval = switch$(n = 1, "daily", n = 7, "weekly", n = 14, "bi-weekly", n = 28, "every 4-weeks")
         IF LEN(COMMAND$) THEN 'loaded from File menu of 'myBackup.exe'
            s = "Ok for next autoBackup to run " + sInterval + " at 2am, beginning " + nextBackup + "?"
            n = MSGBOX(s, %MB_ICONQUESTION OR %MB_YESNO, "Run AutoBackup")
            IF n = %IDNO THEN DIALOG END CB.HNDL: EXIT FUNCTION
         ELSE 'loaded from Windows Startup
            s = "AutoBackup is scheduled to run " + sInterval + $CRLF + $CRLF _
              + "Next backup will run at 2am on " + nextBackup
            MSGBOX s, %MB_ICONINFORMATION OR %MB_OK, "Run AutoBackup"
         END IF
         DIALOG POST CB.HNDL, %WM_USER + 100, 0, 0
      CASE %WM_USER + 100
         DO
            IF wait THEN setWaitForWakeup
            'doesn't leave setWaitForWakeup routine until time to backup
            openTheFile
            DIALOG END hStatus
            IF runNow THEN 'check for target and run backup
               t = TIMER
               DO 'give network 30 secs time to find sCopyTo folder
                  IF TIMER - t >= 30 THEN EXIT DO
               LOOP UNTIL ISFOLDER(sCopyTo)
               IF ISFOLDER(sCopyTo) THEN
                  autoBackupDlg
               ELSE
                  s = "Target folder not found... backup not run"
                  MSGBOX s, %MB_ICONINFORMATION OR %MB_OK, sCopyTo
               END IF
            END IF
            'compute next scheduled auto backup date ---------------------------------------------
            day = VAL(MID$(date$, 4, 2))
            mo = VAL(MID$(date$, 1, 2))
            yr = VAL(MID$(date$, 7, 4))
            day = day + autoInterval
            maxDays = daysInMonth(mo, yr)
            if day > maxDays then day = day - maxDays: incr mo
            if mo > 12 then mo = 1: incr yr
            nextBackup = FORMAT$(mo, "00-") + FORMAT$(day, "00-") + FORMAT$(yr, "0000")
            'reset timer and update autoBackup file ----------------------------------------------
            hFile = FREEFILE 'update autoBackup file
            OPEN sAutoFile FOR BINARY AS #hFile
            n = LEN(thisFile): PUT #hFile,, n: PUT #hFile,, thisFile
            PUT #hFile,, autoInterval
            PUT #hFile,, nextBackup
            CLOSE #hFile
            wait = 1: runNow = 1
         LOOP
      CASE %WM_DESTROY
   END SELECT
END FUNCTION

FUNCTION alreadyRunning(hMutex AS LONG, mutexName AS ASCIIZ *64) AS LONG
   'check if instance of program is already running
   'Returns: 1  already running
   '         0  first instance
   hMutex = CreateMutex (BYVAL %NULL, %FALSE, BYVAL VARPTR(mutexName))
   IF hMutex THEN 'got a handle, but was it already existing?
      IF GetLastError = %Error_Already_Exists THEN FUNCTION = 1
   END IF
END FUNCTION

FUNCTION getSleepTime() AS DWORD
   'compute seconds of sleep time before next scheduled backup
   'backup at 2am today plus autoInterval moreDays of 24 hours
   LOCAL hrs, mins, secs AS LONG
   hrs = VAL(PARSE$(time$, ":", 1)) - 2
   mins = VAL(PARSE$(time$, ":", 2)): secs = VAL(PARSE$(time$, ":", 3))
   FUNCTION = 24 * 3600 * autoInterval - (hrs * 3600 + mins * 60 + secs)
END FUNCTION

FUNCTION daysInMonth(mo AS LONG, yr AS LONG) AS LONG
   LOCAL days AS INTEGER
   IF mo < 8 THEN
      days = 30 + mo MOD 2
   ELSE
      days = 30 + (mo + 1) MOD 2
   END IF                                                               
   IF mo = 2 THEN
      days = 28
      IF (yr MOD 100 <> 0 OR yr MOD 400 = 0) _
         AND yr MOD 4 = 0 THEN INCR days 'leap yr
   END IF
   function = days
END FUNCTION

SUB autoBackupDlg()
   DIALOG NEW hMain, "Running Auto Backup", , , 200, 140 TO hStatus
   CONTROL ADD LABEL, hStatus, %IDC_Start, "", 15, 20, 175, 15
   CONTROL ADD LABEL, hStatus, %IDC_Done, "", 15, 50, 175, 30
   CONTROL ADD BUTTON, hStatus, %IDOK, "", 70, 100, 60, 25
   DIALOG SHOW MODAL hStatus, CALL autoBackupDlgProc
END SUB

CALLBACK FUNCTION autoBackupDlgProc()
   LOCAL t, start, hh, mm, ss AS DOUBLE
   LOCAL s, s1, hrs, mins, secs, sTime AS STRING
   SELECT CASE AS LONG CB.MSG
      CASE %WM_INITDIALOG
         DIALOG POST CB.HNDL, %WM_USER + 100, 0, 0
      CASE %WM_COMMAND
         IF CB.CTL = %IDOK THEN
            IF running = 1 THEN  'interrupted
                running = 0
            ELSE
               DIALOG END CB.HNDL
            END IF
         END IF
      CASE %WM_USER + 100  'backup now
         s = "Auto backup started: " + date$ + " at " + time$ + "am"
         CONTROL SET TEXT CB.HNDL, %IDC_Start, s + $CRLF
         CONTROL SET TEXT CB.HNDL, %IDC_Done, ""
         CONTROL SET TEXT CB.HNDL, %IDOK, "Stop"
         DIALOG REDRAW CB.HNDL
         KILL dataFolder + "myBackup.log"
         logFile = FREEFILE
         OPEN dataFolder + "myBackup.log" FOR OUTPUT AS logFile
         PRINT #logFile, "AutoBackup date: " + DATE$
         PRINT #logFile, "AutoBackup time: " + TIME$
         PRINT #logFile, "AutoBackup File: " + sAutoFile
         PRINT #logFile, ""
         CLOSE #logFile
         IF ISFOLDER(sCopyTo) = 0 THEN 'target is unavailable
            s = "Target folder not found" + $CRLF +"... This auto backup will be aborted"
            CONTROL SET TEXT CB.HNDL, %IDC_Done, s
            CONTROL SET TEXT CB.HNDL, %IDOK, "Ok"
            OPEN dataFolder + "myBackup.log" FOR APPEND AS logFile
            PRINT #logFile, s: CLOSE #logFile
            EXIT FUNCTION
         END IF
         start = TIMER
         backupFiles
         'show the backup time ----------------------------------------------------------------
         t = TIMER - start
         hh = t\3600: mm = (t-3600*hh)\60: ss = t-3600*hh-60*mm
         if hh >= 1 then
            mm = mm + ss/60
            sTime = format$(hh,"0") + " hours and " + format$(mm,"0.00") + " minutes"
         elseif mm >= 1 then
            mm = mm + ss/60
            sTime = sTime + format$(mm,"0.00") + " minutes"
         elseif ss > 1 then
            sTime = sTime + format$(ss,"0") + " seconds"
         else
            sTime = "less than a second"   
         end if
         'display the results -----------------------------------------------------------------
         s1 = "AutoBackup completed: "
         IF running = -2 THEN s1 = "AutoBackup interrupted: "
         s = s1 + $CRLF + STR$(numFiles) + " files copied in " + sTime
         CONTROL SET TEXT hStatus, %IDC_Done, s
         CONTROL SET TEXT CB.HNDL, %IDOK, "Ok"
         'append results of backup to log file ------------------------------------------------
         OPEN dataFolder + "myBackup.log" FOR APPEND AS logFile
         PRINT #logFile, " "
         PRINT #logFile, s1
         PRINT #logFile, STR$(numFiles) + " files copied in " + sTime + " to " + sCopyTo
         CLOSE #logFile: running = -1
   END SELECT
END FUNCTION

SUB backupFiles()
   'copy files from multiple source folders to a single folder
   'copyTo = "F:\my Backup"
   'source = "C:\PBWin90
   'target = "F:\myBackup\HP Laptop\PBWin90"
   '------------------------------------------------------------------------
   LOCAL i, n AS LONG
   LOCAL s AS STRING
   running = 1: numFiles = 0
   createFolder sCopyTo
   FOR i = 1 TO numSources
      IF running = 0 THEN running = -2: EXIT SUB 'auto backup interrupted
      sSource = sources(i)
      IF ISFOLDER(sSource) THEN
         CONTROL SET TEXT hStatus, %IDC_Done, "Backing up: " + sSource
         n = INSTR(-2, sSource, "\"): s = MID$(sSource, n + 1)
         sTarget = sCopyTo + s: copyDir sSource
      ELSE
         OPEN dataFolder + "myBackup.log" FOR APPEND AS logFile
         PRINT #logFile, " "
         PRINT #logFile, "*** Source not found: " + sSource
         PRINT #logFile, " "
      END IF
   NEXT i
   running = -1
END SUB

SUB copyDir(BYVAL sPath AS STRING)
   'recursively finds and copies file structure
   '--------------------------------------------------------
   LOCAL s, s1, sDateMod, sDateMod1, sDateMod0 AS STRING
   LOCAL hSearch, hSrch, i AS LONG           'search handle
   LOCAL WFD, WFD1 AS WIN32_FIND_DATA        'find file data structure
   LOCAL mask AS ASCIIZ * %MAX_PATH          'what to search for

   sPath = RTRIM$(sPath, "\") + "\"
   s = MID$(sPath, LEN(sSource) + 1)
   createFolder sTarget + s
   mask = sPath + "*.*"                       'mask lists where and what files to find
   hSearch = FindFirstFile(mask, WFD)         'get handle of first file found
   IF hSearch <> %INVALID_HANDLE_VALUE THEN   'loop through directory for files

      DO
         DIALOG DOEVENTS 0: IF running = 0 THEN EXIT SUB
         IF BIT(WFD.dwFileAttributes, 4) THEN 'this is a folder
            IF WFD.cFileName <> "." AND WFD.cFileName <> ".." THEN
               s = lcase$(sPath + WFD.cFileName)
               for i = 1 to numExcept
                  if instr(s, except(i)) then iterate do
               next i
               copyDir s
            END IF
         ELSE
            sDateMod = getFileDateTime(WFD.ftLastWriteTime): sDateMod1 = "00000000"
            IF running THEN 'determine modify date of corresponding target file
               hSrch = FindFirstFile(sTarget + s + WFD.cFileName, WFD1)
               IF (hSrch > 0) AND _
                  (WFD1.dwFileAttributes AND %FILE_ATTRIBUTE_DIRECTORY ) <> %FILE_ATTRIBUTE_DIRECTORY THEN
                  sDateMod1 = getFileDateTime(WFD1.ftLastWriteTime)
               END IF
            END IF
            IF running AND sDateMod > sDateMod1 THEN 'copy file
               FILECOPY sPath + WFD.cFileName, sTarget + s + WFD.cFileName
               nErr = ERRCLEAR: IF nErr = %ERR_DISKFULL THEN running = 0
               'print results to myBackup.log ---------------------------------------------------
               IF nErr THEN
                  s1 = "ERROR - " + ERROR$(nErr)
               ELSE
                  sDateMod0 = sDateMod1
                  hSrch = FindFirstFile(sTarget + s + WFD.cFileName, WFD1): FindClose hSrch
                  IF hSrch > 0 THEN sDateMod1 = getFileDateTime(WFD1.ftLastWriteTime)
                  IF sDateMod1 > sDateMod0 THEN 'copied to target
                     INCR numFiles: s1 = ""
                  ELSE 'not copied to target
                     s1 = "Error - Possible virus detected"
                  END IF
               END IF
               OPEN dataFolder + "myBackup.log" FOR APPEND AS logFile
               PRINT #logFile, sPath + WFD.cFileName
               IF LEN(s1) THEN PRINT #logFile, s1
               CLOSE #logFile
            END IF
         END IF
      LOOP WHILE FindNextFile(hSearch, WFD)
   END IF
   FindClose hSearch
END SUB

SUB openTheFile()
   LOCAL hFile, i, n AS LONG
   hFile = FREEFILE
   OPEN thisFile FOR BINARY AS #hFile
   GET #hFile,, numSources
   GET #hFile,, n: sCopyTo = SPACE$(n): GET #hFile,, sCopyTo
   REDIM sources(numSources)
   FOR i = 1 TO numSources
      GET #hFile,, n: sources(i) = SPACE$(n): GET #hFile,, sources(i)
   NEXT i
   n = SEEK(#hFile)
   seek #hFile, n + 4*numSources  'seek past lastDate()
   geT #hFile,, numExcept
   redim except(1 to numExcept)
   FOR i = 1 TO numExcept
      GET #hFile,, n: except(i) = SPACE$(n): GET #hFile,, except(i)
   NEXT i
   CLOSE #hFile
END SUB

SUB createFolder(BYVAL folder AS STRING)
   LOCAL i, n AS LONG
   LOCAL f, s, sNet AS STRING
   IF LEFT$(folder, 2) = "\\" THEN 'UNC network path
      sNet = "\\": folder = MID$(folder, 3)
   END IF
   n = PARSECOUNT(folder, "\")
   FOR i = 1 TO n
      f = PARSE$(folder, "\", i)
      IF LEN(f) THEN
         s = s + f + "\"
         IF ISFOLDER(s) = 0 THEN MKDIR sNet + s
      END IF
   NEXT i
END SUB

'FUNCTION daysInMonth(mo AS LONG, yr AS LONG) AS LONG
'   LOCAL days AS INTEGER
'   IF mo < 8 THEN
'      days = 30 + mo MOD 2
'   ELSE
'      days = 30 + (mo + 1) MOD 2
'   END IF
'   IF mo = 2 THEN
'      days = 28
'      IF (yr MOD 100 <> 0 OR yr MOD 400 = 0) _
'         AND yr MOD 4 = 0 THEN INCR days 'leap yr
'   END IF
'   daysInMonth = days
'END FUNCTION

SUB setWaitForWakeup()
   LOCAL tq AS QUAD
   LOCAL n AS LONG
   LOCAL htimer AS DWORD
   'waitable timer: time in 100 nanosecond intervals (neg for relative time)
   htimer = CreateWaitableTimer(BYVAL %NULL, 1, "AutoBackupTimer")
   IF htimer THEN
      tq = -10000000 * getSleeptime
      SetWaitableTimer BYVAL htimer, tq, 0, BYVAL %NULL, BYVAL %NULL, 1
      WaitForSingleObject BYVAL htimer, %INFINITE
      CloseHandle htimer
   END IF
END SUB

FUNCTION getFileDateTime(dt AS FILETIME) AS STRING
   'return string: year & month & day & hour & minute
   '------------------------------------------------------------------
   LOCAL lpsystime AS SYSTEMTIME
   LOCAL sDate AS ASCIIZ * 32 'date buffer
   LOCAL sTime AS ASCIIZ * 32 'time buffer

   'set the last modified date & time and the get the correct formats
   CALL FileTimeToLocalFileTime(dt, dt)
   CALL FileTimeToSystemTime(dt, lpsystime)

   CALL GetDateFormat (%LOCALE_SYSTEM_DEFAULT, %DATE_SHORTDATE, BYVAL VARPTR(lpsystime), _
                        BYVAL %NULL, sDate, 32)
   CALL GetTimeFormat (%LOCALE_SYSTEM_DEFAULT, %TIME_FORCE24HOURFORMAT OR %TIME_NOSECONDS, _
                        BYVAL VARPTR(lpsystime), BYVAL %NULL, sTime, 32)
   FUNCTION = PARSE$(sDate, "/", 3) _
            + RIGHT$("0" + PARSE$(sDate, "/", 1), 2) _
            + RIGHT$("0" + PARSE$(sDate, "/", 2), 2) _
            + RIGHT$("0" + PARSE$(sTime, ANY ": ", 1), 2) _
            + RIGHT$("0" + PARSE$(sTime, ANY ": ", 2), 2)
END FUNCTION

FUNCTION SpecialFolder(pidl AS DWORD) AS STRING
' by Wayne Diamond 12-03-01
' http://www.powerbasic.com/support/forums/Forum7/HTML/001233.html
'----------------------------------------------------------------------
   LOCAL TmpAsciiz AS ASCIIZ * %MAX_PATH
   CoInitialize BYVAL 0
   IF ISFALSE(SHGetSpecialFolderLocation(BYVAL %HWND_DESKTOP, BYVAL pidl, BYVAL VARPTR(pidl))) THEN
      SHGetPathFromIDList BYVAL pidl, TmpAsciiz
      CoTaskMemFree BYVAL pidl
   END IF
   CoUninitialize
   FUNCTION = TmpAsciiz
END FUNCTION

FUNCTION getProcID(progName AS STRING) AS DWORD
   'Enumerate Processes by Semen Matusovski
   'http://www.powerbasic.com/support/forums/Forum7/HTML/001497.html (08-03-2002)
   'return procID if found, otherwise return 0
   '=======================================================================================
   LOCAL hKernel32, hCreateToolhelp32Snapshot, hProcess32Next, hProcess32First AS DWORD
   LOCAL hModule32First, hModule32Next, hPsApiDll, hEnumProcesses, hProcessSnap AS DWORD
   LOCAL hGetModuleFileNameEx, hEnumProcessModules, nModules, cb, cbNeeded, i AS DWORD
   LOCAL nProcesses, hProcess, procID AS DWORD, lResult1 AS LONG, processName AS STRING
   LOCAL os AS OSVERSIONINFO, pe AS PROCESSENTRY32

   processName = LCASE$(progName)
   os.dwOSVersionInfoSize = SIZEOF(os)
   GetVersionEx BYVAL VARPTR(os)

   IF ISFALSE(os.dwPlatformId = %VER_PLATFORM_WIN32_NT) THEN 'Windows 95/98
      hKernel32                 = GetModuleHandle("kernel32.dll")
      hCreateToolhelp32Snapshot = GetProcAddress(hKernel32, "CreateToolhelp32Snapshot")
      hProcess32Next            = GetProcAddress(hKernel32, "Process32Next")
      hProcess32First           = GetProcAddress(hKernel32, "Process32First")
      hModule32First            = GetProcAddress(hKernel32, "Module32First")
      hModule32Next             = GetProcAddress(hKernel32, "Module32Next")

      CALL DWORD hCreateToolhelp32Snapshot USING CreateToolhelp32Snapshot (%TH32CS_SNAPPROCESS, 0&) TO hProcessSnap
      IF hProcessSnap <> %INVALID_HANDLE_VALUE THEN
         pe.dwSize = SIZEOF(pe)
         CALL DWORD hProcess32First USING Process32First (hProcessSnap, pe) TO lResult1
         DO WHILE lResult1
            IF INSTR(LCASE$(pe.szExeFile), processName) THEN
               procID = pe.th32ProcessID: EXIT DO
            END IF
            CALL DWORD hProcess32Next USING Process32Next (hProcessSnap, pe) TO lResult1
         LOOP
         CloseHandle hProcessSnap
     END IF

   ELSE ' Windows NT
      hPsApiDll = GetModuleHandle("psApi.dll")
      IF hPsApiDll = 0 THEN hPsApiDll = LoadLibrary("psApi.dll")
      hEnumProcesses       = GetProcAddress(hPsApiDll, "EnumProcesses")
      hGetModuleFileNameEx = GetProcAddress(hPsApiDll, "GetModuleFileNameExA")
      hEnumProcessModules  = GetProcAddress(hPsApiDll, "EnumProcessModules")

      cb = 100
      DO
         REDIM ProcessIDs(1 TO cb \ 4) AS DWORD
         CALL DWORD hEnumProcesses USING EnumProcesses (ProcessIDs(1), cb, cbNeeded) TO lResult1
         IF cb > cbNeeded THEN EXIT DO ELSE cb = cb + cb
      LOOP
      nProcesses = cbNeeded \ 4
      FOR i = 1 TO nProcesses
         hProcess = OpenProcess(%PROCESS_QUERY_INFORMATION OR %PROCESS_VM_READ, %False, ProcessIDs(i))
         IF hProcess THEN
            cb = 100
            DO
               REDIM Modules(1 TO cb / 4) AS DWORD
               CALL DWORD hEnumProcessModules USING EnumProcessModules (hProcess, Modules(1), cb, cbNeeded) TO lResult1
               IF lResult1 = 0 THEN cbNeeded = 0: ITERATE FOR
               IF cb > cbNeeded THEN EXIT DO ELSE cb = cb + cb
            LOOP
            nModules = cbNeeded / 4
            CALL DWORD hGetModuleFileNameEx USING GetModuleFileNameEx (hProcess, Modules(1), pe.szExeFile, SIZEOF(pe.szExeFile)) TO lResult1
            CloseHandle hProcess
            IF INSTR(LCASE$(pe.szExeFile), processName) THEN
               procID = ProcessIDs(i): EXIT FOR
            END IF
         END IF
      NEXT
   END IF
   FUNCTION = procID
END FUNCTION
